/***********************************************************************/
/*** (C) Copyright A. Mangen 1994,                                   ***/
/***   Modified by C. Nguyen 1998                                    ***/
/***********************************************************************/
/*** PROJECT     : RAY TRACING PROGRAM                               ***/
/*** PROGRAM NAME: TGA.CC                                            ***/
/*** VERSION     : 1.3                                               ***/
/***-----------------------------------------------------------------***/
/*** DESCRIPTION : TARGA Graphic File Interface                      ***/
/***********************************************************************/

#include <stdio.h>
#include <string.h>

#include "tga.h"

TGAFile::TGAFile(char* FileName, int Width, int Height)
{
  long i,j;
  char h1, h2;

   if(FileName==NULL)
      fp=NULL;
   else
   {  fp=fopen(FileName,"wb");
      // determines how stream will  be  buffered
      setvbuf(fp,NULL,_IOFBF,32767);
      // initialize the header of targa file to 0
      memset(&H,0,sizeof(struct TGAHeader));
      // Uncompressed RGB
      H.ImageTypeCode=2;                 
      BytesPerPixel=3;
      H.Width=Width;                           // Image Width
      H.Height=Height;                         // Image Height
      H.ImagePixelSize=8*BytesPerPixel;
      H.ImageDescriptorByte=0x20;              // Flip vertically
      // fwrite(&H,sizeof(struct TGAHeader),1,fp); KO
      fwrite(&H.IdLength,1,1,fp);
      fwrite(&H.ColorMapType,1,1,fp);
      fwrite(&H.ImageTypeCode,1,1,fp);
      fwrite(&H.ColorMapOrigin,2,1,fp);
      fwrite(&H.ColorMapLength,2,1,fp);
      fwrite(&H.ColorMapEntrySize,1,1,fp);
      fwrite(&H.XOrigin,2,1,fp);
      fwrite(&H.YOrigin,2,1,fp);
      // we must exchange the two bytes of the short int
      h1 = (char) H.Width;
      h2 = (char) (H.Width >> 8);
      fwrite(&h1,1,1,fp);
      fwrite(&h2,1,1,fp);
      h1 = (char) H.Height;
      h2 = (char) (H.Height >> 8);
      fwrite(&h1,1,1,fp);
      fwrite(&h2,1,1,fp);
      fwrite(&H.ImagePixelSize,1,1,fp);
      fwrite(&H.ImageDescriptorByte,1,1,fp);
   }
}

TGAFile::~TGAFile()
{
  if(fp!=NULL) fclose(fp);
  fp=NULL;
}

void TGAFile::WriteLine(int n, char* color)
{
  if(fp!=NULL) fwrite(color,BytesPerPixel,n,fp);
}

void TGAFile::WritePixel(char* color)
{
  if(fp!=NULL) fwrite(color,BytesPerPixel,1,fp);
}
